local gr = love.graphics
local path = require 'path'

function love.load()
	love.window.setTitle( 'Simple String Defined Path - e.g. rrrr or 4[r] creates a square (4 right turn steps)' )
	ln = {
		'u4[ul3[rrl]ul]',
		'u4[u3[lwrw]lul]',
		'3[5[3[u]ru2[uur]urrllu2[luu]ul]]',
		'4[u9[rl]rru8[rl]ru]',
		'4[3[u]rr2[u]r]',
		'u4[uulurrulluurruull3[rrl]luurruullurruluul]',
		'r4[2[ru]rll]',
		'u8[uw]',
		'w4[wusu]',
		'u4[uwrllrw]',
		'u4[lualaulr]',
		'u8[qaq]',
		'uuq7[rq]',
		'u8[auwuau]',
		'u4[uwlwur]',
		'u8[uwqwur]',
		'r4[rllrru]',
		'q4[rwlw]'
		}
	loc = {
		{ 100, 200 }, { 380, 200 }, {  25, 570 },
		{ 610, 200 }, { 600, 350 }, { 100, 400 },
		{ 400,  75 }, { 525, 500 }, { 645, 505 },
		{  80,  80 }, { 375, 380 }, { 375, 490 },
		{ 590, 100 }, { 290, 490 }, { 220, 230 },
		{ 225,  90 }, { 240, 340 }, { 200, 480 }
		}
	textof = {		-- offset for text (relative to figure)
		{  0, 55,-30, 70 }, {  4,  0,-35, 70 }, {-5, -5, -5, 15 },
		{-10, 50,-60, 80 }, {-10, 35,-40, 50 }, { 0,105,-90,120 },
		{-19,-14,-45, 30 }, { 20,-20, -5, 20 }, { 0,-25,-20, 15 },
		{ 23,-18,  0, 25 }, { 10,-25,-20, 25 }, {13,-13, -5, 30 },
		{ 10,-35,-10,  5 }, { 16, -6,-10, 30 }, {18,-35, -8, 34 },
		{ 13,-30,-15, 15 }, {  0, 45,-15, 60 }, {10,-15,-10, 20 }
		}
	pp = {}		-- create path based on directions (string) and location (table) info
	for i = 1, #ln do
		pp[i] = path.calc( loc[i][1], loc[i][2], ln[i], 10 )
		end
	an = 0
	twoNew = path.edit( pp[2], 750, 200, math.pi/4, 0.5, 0.5 )
	sevenBackground = ellipse( 750, 75, 18, 36 )
	arrow = gr.newImage( 'arrow.png' )
	invisiable = 'u2[3[u]r9[uu]r]'
	inv = path.calc( 200,150,invisiable, 5 )
	invisiable2 = 'u4[u3[lwrw]lul]'
	inv2 = path.calc( 500,200,invisiable2, 8 )
	tree = 'lrul2[uauus]uauur2[uuaus]uuaulur'
	tre = path.calc(470,100,tree,10)
-- for testing only
test = '8[wru]'
tes = path.calc(440,140,test,20)
-- *****************
	end
--[[
\   /	  |
  o  	- o -
/   \ 	  |
]]

function love.update( dt )
	for i = 1, #pp do path.update( pp[i], dt ) end	-- update all path animations
	path.update( twoNew, dt, 0.02 )
	an = an + dt
	sevenNew = path.edit( pp[7], 750, 75, -an, 0.5, 1 )	-- location,angle,scale
	path.update(inv,dt,.08)
	path.update(inv2,dt,.3)
	path.update(tre,dt,.2)
	path.update(tes,dt,.2)
	end

function love.draw()
	path.fillConcave( pp[ 6], {0.6,0.6,0.0,1.0} )
	path.fillConcave( pp[11], {0.9,0.4,0.2,0.8} )
	path.fillConcave( pp[ 2], {0.2,0.6,0.9,0.8} )
	path.fillConcave( pp[ 7], {0.2,0.7,0.2,0.8} )
	path.fillConcave( pp[12], {0.8,0.0,0.8,0.8} )
	path.fillConcave( pp[13], {0.8,0.0,0.8,0.8} )
	for i = 1, #pp do
		gr.setColor( 1, 1, 1 )
		path.drawtext( i )
		path.draw( pp[i], { 1, 1, 1 } )
		path.animate( pp[i], { 0, 0, 1 } )
		end
	path.draw( twoNew, { 1, 1, 1 } )
		path.fillConcave( twoNew, { 0.2, 0.6, 0.9, 0.8 } )
		path.animate( twoNew, { 1, 1, 0 } )
		gr.print( '2', 745, 192 )
	gr.setColor( 1, 0, 0 )
		gr.polygon('fill', unpack( sevenBackground ) )
		path.fillConcave( sevenNew, { 0.5, 0.5, 0 } )
		path.draw( sevenNew, { 1, 1, 1 } )
		gr.print( '7', 745, 65 )
		path.animate( sevenNew, { 0, 1, 0 } )
	path.Draw( pp[6], 725, 400, an, 0.6, 0.6, { 1, 0, 0, 1 } )
		gr.setColor(1,1,1)
		gr.print( '6', 722, 392 )
	path.animate( inv, { 1, 1, 0 } )	-- note: no path.draw - only trail shown
		gr.print( 'Invisable Path', 207, 133 )
		gr.print( invisiable, 199, 155 )
		path.animate( inv2, { .3, .3, .7 } )
	path.fillConcave( tre, {0,1,0,.4} )
		path.animate( tre, {0,1,0} )
		gr.print( tree, 370, 5 )
		gr.print( 'tree', 450, 105 )
	path.fillConcave( tes, {0.4,0.0,0.8,0.8} )
		path.draw( tes, { .5, 0, 0 } )
		path.animate( tes, {0,1,0} )
		gr.print( test,438 ,147 )

	gr.print( 'fps: '..love.timer.getFPS( ), 10, 10 )
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.quit() end
	end

ellipse = function( x, y, sx, sy )
	local elp, st = {}, 18/(sx+sy)
	for a = 0, 2*math.pi,st do
		elp[#elp+1] = sx*math.cos(a) + x
		elp[#elp+1] = sy*math.sin(a) + y
		end
	elp[#elp+1] = elp[1]
	elp[#elp+1] = elp[2]
	return elp
	end
